%define title Snd
%define snd_guile_ver 1.7.0-alt0.7cvs20021021
%define snd_temp_dir ~/.snd
%define snd_save_dir %snd_temp_dir/state

%def_with gui
%def_with gui_gtk
%def_with gui_motif
# lesstif gui is not recommended.
%def_without gui_lesstif
%def_with sndutils
%def_without gl
%def_with guile
%def_without ruby
# Snd needs guile >=1.5.4
%def_with sys_guile
%def_without alsa
%def_without esound

# without gui build snd-utils only.
%if_without gui
%def_without gui_gtk
%def_without gui_motif
%def_without gui_lesstif
%def_with sndutils
%endif

%define sndutils sndplay sndrecord sndinfo audinfo sndsine

%define ver_major 6
%define ver_minor 12
%define snapshot_date 20031011

Name: snd
Version: %ver_major.%ver_minor
Release: alt1cvs%snapshot_date

Summary: Snd - sound editor
Summary(ru_RU.KOI8-R): Snd -   
License: LGPL
Group: Sound
Url: http://www-ccrma.stanford.edu/software/snd
Packager: Yuri N. Sedunov <aris@altlinux.ru>

# really every time we are building a cvs snapshot
#Source: ftp://ccrma-ftp.stanford.edu/pub/Lisp/%name-%ver_major.tar.gz
Source: %name-%ver_major.%ver_minor-%snapshot_date.tar.bz2
Source1: %name-48x48.xpm
Source2: %name-32x32.xpm
Source3: %name-16x16.xpm

Patch: %name-6.12-alt-html_dir.patch
#Patch1: %name-6.12-20031011-alt-plugins.patch

%if_with sys_guile
BuildConflicts: snd-guile-devel
BuildPreReq: guile16-devel >= 1.6.4
%else
BuildPreReq: snd-guile-devel >= %snd_guile_ver
%endif

%if_with gui_gtk
BuildRequires: XFree86-devel XFree86-libs fontconfig freetype2-devel glib2-devel ladspa_sdk libXft-devel libatk-devel libexpat libfftw3-devel libgsl-devel libgtk+2-devel libpango-devel pkgconfig
%endif

%if_with gui_motif
BuildRequires: XFree86-devel XFree86-libs ladspa_sdk libXmHTML-devel libfftw3-devel libgsl-devel libjpeg-devel libpng-devel openmotif-devel xpm-devel
%endif

%if_with sndutils
%if_without gui
BuildRequires: snd-guile-devel ladspa_sdk libalsa2-devel libgsl-devel
%endif
%endif

%if_with ruby
BuildRequires: ruby-devel
%endif

%if_with alsa
BuildRequires: libalsa2-devel
%endif

%if_with esound
BuildRequires: esound-devel libaudiofile-devel
%endif

%description
Snd is a sound editor modeled loosely after Emacs and an old,
sorely-missed PDP-10 sound editor named Dpysnd. It can accommodate any
number of sounds each with any number of channels, and can be customized
and extended using Guile or Ruby.

%if_with gui_gtk
%package gtk
Summary: Snd - sound editor with Gtk interface
Summary(ru_RU.KOI8-R): Snd -     GTK 
Group: Sound
Provides: %name = %version-%release
Obsoletes: %name
Requires: %name-common = %version-%release

%description gtk
Snd is a sound editor modeled loosely after Emacs and an old,
sorely-missed PDP-10 sound editor named Dpysnd. It can accommodate any
number of sounds each with any number of channels, and can be customized
and extended using Ruby. This package contains Snd with GTK interface.
You must also to install %name-common  package to run Snd. You may
install without conflicts %name-motif and %name-lesstif package and use
all.
%endif

%if_with gui_motif
%package motif
Summary: Snd - sound editor with motif interface
Summary(ru_RU.KOI8-R): Snd -     Motif .
Group: Sound
Provides: %name = %version-%release
Provides: %name-motif-static = %version-%release
Obsoletes: %name-motif-static
Requires: %name-common = %version-%release 
#Requires: %name-plugins = %version-%release 

%if_with sys_guile
Requires: guile >= 1.5.4
%else
Requires: snd-guile >= %snd_guile_ver
%endif

%description motif 
Snd is a sound editor modeled loosely after Emacs and an old,
sorely-missed PDP-10 sound editor named Dpysnd. It can accommodate any
number of sounds each with any number of channels, and can be customized
and extended using Guile. This package contains Snd with motif
interface (statically linked). You must also to install %name-common 
package to run Snd. You may install without conflicts %name-gtk and
%name-lesstif package and use all.
%endif

%if_with gui_lesstif
%package lesstif
Summary: Snd - sound editor with lesstif interface
Summary(ru_RU.KOI8-R): Snd -     Lesstif 
Group: Sound
Provides: %name = %version-%release
Obsoletes: %name
Requires: %name-common = %version-%release

%if_with sys_guile
Requires: guile >= 1.5.4
%else
Requires: snd-guile >= %snd_guile_ver
%endif

%description lesstif
Snd is a sound editor modeled loosely after Emacs and an old,
sorely-missed PDP-10 sound editor named Dpysnd. It can accommodate any
number of sounds each with any number of channels, and can be customized
and extended using Guile. This package contains Snd with lesstif
interface . You must also to install %name-common  package to run Snd.
You may install without conflicts %name-gtk and %name-motif
package and use all.
%endif

%package common
Summary: Files needed to run and customize Snd (Sound editor) 
Summary(ru_RU.KOI8-R): ,      Snd.
Group: Sound
Requires: %name = %version-%release

%description common
This package contains Guile and Ruby scripts, manpage, system wide
config file - %_sysconfdir/snd.conf, sample of ~/.snd file for customizing Snd.

%if_with sndutils
%package utils
Summary: A set of small commandline sound utilities 
Summary(ru_RU.KOI8-R):       .
Group: Sound

%description utils
This package contains a set of small commandline sound utilities
(%sndutils) from distribution of Snd (sound editor).  
%endif

%package doc
Summary: A documentation for Snd - sound editor
Summary(ru_RU.KOI8-R):   Snd -   .
Group: Sound
Requires: %name = %version-%release

%description doc
Snd is a sound editor modelled loosely after Emacs and an old,
sorely-missed PDP-10 sound editor named Dpysnd. It can accommodate any
number of sounds each with any number of channels, and can be customized
and extended using Guile or Ruby. 

This package contains documentation for Snd. 

%package plugins
Summary: Plugins for Snd - sound editor
Summary(ru_RU.KOI8-R):   Snd -   .
Group: Sound
Requires: %name = %version-%release ladspa_sdk cmt ladspa-swh-plugins lame vorbis-tools mpg123

%description plugins
Snd is a sound editor modelled loosely after Emacs and an old,
sorely-missed PDP-10 sound editor named Dpysnd. It can accommodate any
number of sounds each with any number of channels, and can be customized
and extended using Guile or Ruby. This package contains plugins for Snd. 

%define _snd_docdir %_docdir/%name-%version
%define _snd_html_docdir %_snd_docdir/HTML

%prep
%setup -n %name-%ver_major
%patch -p1
#%patch1 -p1

%if_with sys_guile
%__subst 's,/usr/local/bin/guile,'$(guile-config info bindir)'/guile,' *.scm
%else
%__subst 's,/usr/local/bin/guile,/usr/lib/snd/bin/guile,' *.scm
%endif

%build
%define options --with-temp-dir=%snd_temp_dir --with-save-dir=%snd_save_dir

%if_with gui_gtk
%configure %options \
%if_with ruby
    --with-ruby \
%endif
%if_with guile
    --with-guile \
%endif
%if_with alsa
    --with-alsa \
%endif
%if_with esound
    --with-esd \
%endif
%if_with gl
    --with-gl \
%endif
    --with-gtk --with-static-xm \
    --with-ladspa --with-x

%make_build GSL_FLAGS=""
mv snd snd-gtk
%endif

%if_with gui_motif
(%make_build clean)
%configure %options \
%if_with ruby
    --with-ruby \
%endif
%if_with guile
    --with-guile \
%endif
%if_with alsa
    --with-alsa \
%endif
%if_with esound
    --with-esd \
%endif
%if_with gl
    --with-gl \
%endif
    --with-motif --with-static-xm \
    --with-ladspa --with-x --with-html

%make_build GSL_FLAGS=""
mv snd snd-motif
%make_build clean
%endif

%if_with gui_lesstif
(%make_build clean)
%configure %options \
%if_with ruby
    --with-ruby \
%endif
%if_with guile
    --with-guile \
%endif
%if_with alsa
    --with-alsa \
%endif
%if_with esound
    --with-esd \
%endif
%if_with gl
    --with-gl \
%endif
    --with-ladspa --with-x

%make_build GSL_FLAGS="" 
mv snd snd-lesstif
%endif

%if_with sndutils
(%make_build clean)
%configure %options \
%if_with alsa
    --with-alsa \
%endif
%if_with esound
    --with-esd \
%endif
    --with-no-gui --with-x=no

%make_build GSL_FLAGS="" 
%make_build %sndutils
%endif

%install
%makeinstall
%if_with sndutils
%__cp %sndutils %buildroot%_bindir
%endif

%if_with gui_motif
%__cp snd-motif %buildroot%_bindir
%endif

%if_with gui_lesstif
%__cp snd-lesstif %buildroot%_bindir
%endif

%if_with gui_gtk
%__cp snd-gtk %buildroot%_bindir
%endif

%if_with gui
# install icons
%__install -pD -m644 %SOURCE1 %buildroot%_liconsdir/%name.xpm
%__install -pD -m644 %SOURCE2 %buildroot%_iconsdir/%name.xpm
%__install -pD -m644 %SOURCE3 %buildroot%_miconsdir/%name.xpm

# Creating menus
%__mkdir_p %buildroot%_menudir

%__cat <<__MENU_COMMON__ >%buildroot%_menudir/snd
?package(snd-common): needs="x11" section="Multimedia/Sound/" \
title="Snd" longtitle="Sound editor" icon="%name.xpm"
__MENU_COMMON__

%__cat <<__MENU_GTK__ >%buildroot%_menudir/snd-gtk
?package(snd-gtk): needs="x11" section="Multimedia/Sound/Snd" \
title="Snd (GTK)" longtitle="Sound editor with GTK interface" \
command="%_bindir/snd-gtk -notebook" icon="%name.xpm"
__MENU_GTK__

%__cat <<__MENU_LESSTIF__ >%buildroot%_menudir/snd-lesstif
?package(snd-lesstif): needs="x11" section="Multimedia/Sound/Snd" \
title="Snd (Lesstif)" longtitle="Sound editor with Lesstif interface" \
command="%_bindir/snd-lesstif -notebook" icon="%name.xpm"
__MENU_LESSTIF__

%__cat <<__MENU_MOTIF__ >%buildroot%_menudir/snd-motif
?package(snd-motif): needs="x11" section="Multimedia/Sound/Snd" \
title="Snd (Motif)" longtitle="Sound editor with Motif interface" \
command="%_bindir/snd-motif -notebook" icon="%name.xpm"
__MENU_MOTIF__
%endif

## install common
%__mkdir -p %buildroot%_datadir/%name/{configs,plugins} 
%__mkdir -p %buildroot%_sysconfdir 
%__cp *.scm *.cl *.rb %buildroot%_datadir/%name/

# creating configs
# snd.conf
%__cat <<__SND_CONF__ >%name.conf
(set! %load-path (cons "%_datadir/%name" %load-path))
(set! %load-path (cons "%_datadir/%name/plugins" %load-path))
(set! snd-remember-paths #t)
__SND_CONF__

# .snd  
%__cp %name.conf dot.%name
%__cat <<__DOT_SND__ >> dot.%name

# it works with motif gui only.
;(load-from-path "misc.scm")
__DOT_SND__

%__cp *.ad dot.snd DotEmacs %buildroot%_datadir/%name/configs
%__cp %name.conf %buildroot%_sysconfdir 

## install docs
%__mkdir_p %buildroot%_snd_html_docdir
%__cp *.Snd %buildroot%_snd_docdir
%__cp *.html *.png %buildroot%_snd_html_docdir
%__ln_s %_snd_html_docdir/snd.html %buildroot%_snd_docdir/index.html
%__ln_s %_snd_html_docdir/snd1.html %buildroot%_snd_docdir/index-framed.html

## install plugins
pushd dlp
# small fix
%__subst 's,contrib/\(edit123.scm\),\1,' misc.scm
%__cp * %buildroot%_datadir/%name/plugins
#%__cp *.scm *.rb %buildroot%_datadir/%name/plugins
popd

## install tutorial
%__cp -R tutorial %buildroot%_snd_docdir


%find_lang %name

%post common
%update_menus
%postun common
%clean_menus

%if_with gui_gtk
%post gtk
%update_menus
%postun gtk
%clean_menus
%endif

%if_with gui_lesstif
%post lesstif
%update_menus
%postun lesstif
%clean_menus
%endif

%if_with gui_motif
%post motif
%update_menus
%postun motif
%clean_menus
%endif

%if_with gui_gtk
%files gtk
%_bindir/snd-gtk
%_menudir/snd-gtk
%endif

%if_with gui_motif
%files motif
%_bindir/snd-motif
%_menudir/snd-motif
%endif

%if_with gui_lesstif
%files lesstif
%_bindir/snd-lesstif
%_menudir/snd-lesstif
%endif

%if_with sndutils
%files utils
%_bindir/sndplay
%_bindir/sndrecord
%_bindir/sndinfo
%_bindir/sndsine
%_bindir/audinfo
%endif

%files doc
%dir %_snd_docdir
%_snd_docdir/*.Snd
%_snd_docdir/HTML
%_snd_docdir/tutorial

%files plugins
%_datadir/%name/plugins

%files common -f %name.lang
%_datadir/%name/*.scm
%_datadir/%name/*.rb
%_datadir/%name/*.cl
%_datadir/%name/configs
%_sysconfdir/%name.conf
%_man1dir/*
%_iconsdir/%name.xpm
%_iconsdir/*/%name.xpm
%_menudir/%name

%changelog
* Sun Oct 12 2003 Yuri N. Sedunov <aris@altlinux.ru> 6.12-alt1cvs20031011
- 6.12 

* Sat May 17 2003 Yuri N. Sedunov <aris@altlinux.ru> 6.8-alt1cvs20030516
- new version.

* Wed Jan 15 2003 Yuri N. Sedunov <aris@altlinux.ru> 6.6-alt1cvs20030115
- 6.6 release.

* Wed Oct 16 2002 Yuri N. Sedunov <aris@altlinux.ru> 6.1-alt1cvs20021016
- 6.1 release.

* Tue Jun 11 2002 Yuri N. Sedunov <aris@altlinux.ru> 5.11-alt1cvs20020612
- Gtk OpenGL support via the gtkglext library.
- alsa support temporarily disabled. 
- sndsine removed from utils package.

* Mon May 13 2002 Yuri N. Sedunov <aris@altlinux.ru> 5.10-alt1cvs20020513
- 5.10 
- xg patch removed.

* Tue Apr 16 2002 Yuri N. Sedunov <aris@altlinux.ru> 5.9-alt1cvs20020415
- 5.9

* Fri Apr 12 2002 Yuri N. Sedunov <aris@altlinux.ru> 5.8-alt2.1cvs20020412
- current snapshot.
- only alsa2 supported now.
- snd-gtk built with gtk2 to enable libxm functionality.
- lame instead bladeenc required by snd-plugins
- Buildrequires updated.
- fixed Provides for %name-motif package

* Fri Apr 12 2002 Dmitry V. Levin <ldv@alt-linux.org> 5.8-alt2
- Rebuilt with openmotif-2.2.2.
- Replaced snd-motif-static subpackage with snd-motif (and link
  it dynamically with openmotif since it doesn't conflict with
  lesstif now).

* Fri Mar 15 2002 Yuri N. Sedunov <aris@altlinux.ru> 5.8-alt1
- 5.8

* Thu Feb 28 2002 Yuri N. Sedunov <aris@altlinux.ru> 5.7-alt0.9
- new version
- html help works with snd-motif

* Sun Jan 27 2002 Yuri N. Sedunov <aris@altlinux.ru> 5.6-alt0.8
- new version.
- built with snd-guile
- Provides, requires, descriptions corrected.

* Tue Dec 20 2001 Yuri N. Sedunov <aris@altlinux.ru> 5.5-alt0.8
- Updated to 5.5. Built with guile-1.7.0-alt0.2, guile extentions works
- Ruby support for snd-gtk ang guile for snd-{motif,lesstif}. 

* Wed Nov 21 2001 Yuri N. Sedunov <aris@altlinux.ru> 5.4-alt5
- files list for doc package corrected. Scripts moved to common
  package.
- sample of ~/.snd file and system config /etc/snd.conf added.
- Russian summary added.

* Wed Nov 21 2001 Yuri N. Sedunov <aris@altlinux.ru> 5.4-alt4
- Lesstif package added. Why? Not ask me. 

* Mon Nov 19 2001 Yuri N. Sedunov <aris@altlinux.ru> 5.4-alt3
- package common. Removed Conflicts, different builds of Snd may
  be installed without conflicts.

* Sun Nov 18 2001 Yuri N. Sedunov <aris@altlinux.ru> 5.4-alt2
- Dave Phillips plugins in separate package. Will be more plugins.
- Icons added.

* Thu Nov 16 2001 Yuri N. Sedunov <aris@altlinux.ru> 5.4-alt1
- In HISTORY.Snd found real version number - 5.4 (Nov 5 2001) 
- Remove html help support - it does not work properly.
  Html documentation and contributed by Dave Phillips plugins 
  separated in doc package. 
- Replaced $RPM_BUILD_ROOT with macro buildroot. Why not?. 
- Spec cleanup.
- Built both gtk and static motif versions.

* Sat Nov 10 2001 Yuri N. Sedunov <aris@altlinux.ru> 5-alt1
- first build for Sisyphus.
